package gui.run;

import math.MathUtils;

import java.awt.Color;

/**
 * DocJava, Inc. http://www.docjava.com
 * Programmer: dlyon Date: Mar 3, 2004 Time:
 * 7:52:32 PM
 */
public abstract class RunColorButton
        extends RunButton {
    private RunJob j = new RunJob(1, true) {
        public void run() {
            Color randomColor
                    = MathUtils.getRandomColor();
            setBackground(randomColor);
            setForeground(randomColor);
        }
    };

    public RunColorButton(String s) {
        super(s);
        j.start();
    }

    private boolean running = true;

    public void toggle() {
        if (running) {
            running = false;
            stop();
            return;
        }
        running = true;
        start();
    }

    public void stop() {
        j.stop();
    }

    public void start() {
        j.start();
    }
}
